#PyMusicQuiz v0.1
#Gavrishev Alexandr (anod)
#mailto: alex.gavrishev@gmail.com
#SYMBIANUID=0x00201519
#
# -*- coding: utf-8 -*-

import appuifw,os,e32,time,codecs,string
from key_codes import *
from graphics import *
from random import *
from audio import *
from sysinfo import battery

class PMQGame:
	def __init__(self):
		global Sound
		self.lock=e32.Ao_lock()
		self.img=None
		self.canvas=appuifw.Canvas(redraw_callback=self.redraw)
		appuifw.app.title = u'PyMusicQuizs'
		appuifw.app.exit_key_handler=self.quit
		appuifw.app.menu=[(u"Set music dir",lambda:self.settings(2)),(u"Set music ext",lambda:self.settings(3))]
		appuifw.app.screen='full'
		appuifw.app.body=self.canvas
		self.img=Image.new(self.canvas.size)
		self.running = 1
		self.mdir = u''
		self.mext = []
		self.farr = []
		self.farr_len = 0
		self.last4 = [('',''),('',''),('',''),('','')]
		self.five = []
		self.three =[]
		self.num = Random()
		self.cplay = 0
		self.sound = Sound
		self.snd = None
		self.s_count = 0
		self.k_count = 0
		self.scr_w = self.canvas.size[0]
		self.scr_h = self.canvas.size[1]
		self.cpos=0
		self.play_time = 8
		self.canvas.bind(EKeyUpArrow,lambda:self.lb_pos(-1))
		self.canvas.bind(EKeyDownArrow,lambda:self.lb_pos(1))
		self.canvas.bind(EKeySelect,lambda:self.lb_select())
		self.coords = (35,50,65,80,95)
		self.result = u''
		self.ton  = 0
		self.sel_press = 0
		self.ct = 0
		self.ct1 = -1
		self.nt = 0
		self.nt1 = 0
		self.score = 0
		self.nt_del=(2,4,6)
		self.path = os.path.split(appuifw.app.full_name())[0]
		if e32.in_emulator():
			self.img_tpl=Image.open(u'c:\\PMQtitle_play.jpg')
			self.img_tbg=Image.open(u'c:\\PMQtitle_bg.jpg')
			self.img_sel=Image.open(u'c:\\PMQsel.jpg')
			self.img_gauge=Image.open(u'c:\\PMQgauge.jpg')
			self.img_batbg=Image.open(u'c:\\PMQbat_bg.jpg')
			self.img_bat1=Image.open(u'c:\\PMQbat_1.jpg')
			self.img_ipod=Image.open(u'c:\\PMQipod.jpg')
		else:
			self.img_tpl=Image.open(self.path+os.sep+u'i'+os.sep+u'PMQtitle_play.jpg')
			self.img_tbg=Image.open(self.path+os.sep+u'i'+os.sep+u'PMQtitle_bg.jpg')
			self.img_sel=Image.open(self.path+os.sep+u'i'+os.sep+u'PMQsel.jpg')
			self.img_gauge=Image.open(self.path+os.sep+u'i'+os.sep+u'PMQgauge.jpg')
			self.img_batbg=Image.open(self.path+os.sep+u'i'+os.sep+u'PMQbat_bg.jpg')
			self.img_bat1=Image.open(self.path+os.sep+u'i'+os.sep+u'PMQbat_1.jpg')
			self.img_ipod=Image.open(self.path+os.sep+u'i'+os.sep+u'PMQipod.jpg')
		self.img_tbg=self.img_tbg.resize((self.scr_w,self.img_tbg.size[1]),keepaspect=0)
		self.img_sel=self.img_sel.resize((self.scr_w,self.img_sel.size[1]),keepaspect=0)

		self.settings(1)
		self.get_files()
		if self.farr_len>5:
			self.next()
		self.redraw(())
	def run(self):
		while self.running:
			self.img.clear(0xf0f5fb)
			self.redraw(())
			e32.ao_yield()
		self.lock.wait()
	def next(self):
		self.take5()
		self.ct = time.clock()
		self.ton = 1
		self.three = []
		self.cplay = self.get_cplay()
		self.s_count += 1
		self.play()
	def play(self):
		file = self.five[self.cplay-1][1]
		if not e32.in_emulator():
			self.snd = self.sound.open(file)
			d = self.snd.duration()
			if (d/1000 >= 10):
				rstart = self.num.randint(0,d-10000)
				self.snd.set_position(rstart)
			self.snd.play(times=3,interval=1)
	def stop(self):
		if not e32.in_emulator():	self.snd.stop()
		self.ton = 0
		self.sel_press = 0
		self.cpos = 0
		self.ct1 = -1
		self.nt1 = 0
		self.result = u''
		self.three = []
	def redraw(self,rect):
		if self.img:
			self.img.blit(self.img_tbg)
			self.img.blit(self.img_tpl)
			self.img.text((self.scr_w/2-5*7,12),u'PyMusicQuiz',0x000000)
			self.bat_redraw()
			self.img.line((0,112,self.scr_w,112),0x627D86)
			self.img.line((0,128,self.scr_w,128),0x627D86)
			if self.farr_len>5:
				self.lb_redraw()
				self.gauge_redraw()
			else:
				self.img.text((self.scr_w/2-6*7,35),u'Not enought',0x000000)
				self.img.text((self.scr_w/2-6*7,50),u'music files',0x000000)
				self.img.text((self.scr_w/2-6*7,65),u'Must be more',0x000000)
				self.img.text((self.scr_w/2-6*7,80),u'than 5 files.',0x000000)
			self.img.text((self.scr_w/2-len(self.result)/2*6,110),unicode(self.result),0x000000)
			score = u'Score: '+unicode(self.score)+' ['+unicode(self.k_count)+u'/'+unicode(self.s_count)+u'] ('+unicode(self.farr_len)+u')'
			self.img.text((self.scr_w/2-len(score)/2*6,125),score,0x000000)
			self.img.blit(self.img_ipod,target=(self.scr_w/2-self.img_ipod.size[0]/2,self.scr_h-self.img_ipod.size[1]))
			self.canvas.blit(self.img)
	def get_files(self):
		for file in os.listdir(str(self.mdir)):
			(shortname, extension) = os.path.splitext(file)
			if string.lower(extension) in self.mext:
				full_name = os.path.join(str(self.mdir), file)
				self.farr.append((unicode(shortname,encoding='utf-8', errors='replace'),unicode(full_name,encoding='utf-8', errors='replace')))
		self.farr_len=len(self.farr)
	def take5(self):
		prevn = []
		self.five = []
		for i in range(1,6):
			n=self.num.randint(0,len(self.farr)-1)
			while n in prevn:
				n=self.num.randint(0,len(self.farr)-1)
				e32.ao_yield()
			prevn.append(n)
			self.five.append(self.farr[n])
	def get_cplay(self):
		n = self.num.randint(0,4)+1
		while (self.five[n-1] in self.last4):
			n = self.num.randint(0,4)+1
			e32.ao_yield()
		self.last4.append(self.five[n-1])
		del self.last4[0]
		return n
	def lb_redraw(self):
		if (self.ton == 1):
			for j in range (0,3):
				if (int(self.nt) == self.nt_del[j])and(len(self.three)==j):
					n = self.num.randint(0,4)+1
					n -= 1
					while (n == self.cplay-1)or(n in self.three):
						n = self.num.randint(0,4)+1
						n -= 1
						e32.ao_yield()
					if n==self.cpos:
						self.lb_pos(+1)
					self.three.append(n)
		ty=self.coords[self.cpos]-12
		self.img.blit(self.img_sel,target=(1,ty))
		for i in range(0,5):
			fcolor=0x000000
			if i == (self.cpos):	fcolor=0xFFFFFF
			if not(i in self.three):
				self.img.text((4,self.coords[i]),unicode(self.five[i][0]),fcolor)
		self.nt=time.clock() - self.ct
		if self.ton == 1:
			if int(self.nt) == self.play_time:
				self.ct1 = time.clock()
				self.result = u'Wrong!'
				self.ton = 0
				self.sel_press=1
				if not e32.in_emulator():	self.snd.stop()
		if (self.ct1 != -1):	self.nt1=int(time.clock() - self.ct1)
		if (self.sel_press and self.nt1==2):
			self.stop()
			self.next()
	def lb_pos(self,pos):
		if self.ton == 1:
			self.cpos=self.cpos+pos
			if (self.cpos)<0:
				self.cpos=4
			if (self.cpos)>4:
				self.cpos=0
			if self.cpos in self.three:
				self.lb_pos(pos)
	def lb_select(self):
		if (self.farr_len>5)and(self.ton == 1):
			self.sel_press = 1
			self.ton = 0
			self.ct1 = time.clock()
			if self.cpos == self.cplay-1:
				self.result = u'Correct!'
				self.k_count += 1
				self.score += int((self.play_time-self.nt)*100)
			else:	self.result = u'Wrong!'
			if not e32.in_emulator():	self.snd.stop()
	def gauge_redraw(self):
		tx=50
		ty=102
		if self.ton and (self.play_time-self.nt>=0):
			self.img.blit(self.img_gauge,target=(tx,ty))
			self.img.rectangle((50+self.nt*100/self.play_time,102,50+100,110),0x000000,0xf0f5fb)
			self.img.text((25,110),unicode(int((self.play_time-self.nt)*100)),0x000000)
	def bat_redraw(self):
		self.img.blit(self.img_batbg,target=(self.scr_w-self.img_batbg.size[0],0))
		level = battery()
		img_batlevel=None
		img_batlevel=self.img_bat1.resize((level*2,self.img_bat1.size[1]))
		self.img.blit(img_batlevel,target=(self.scr_w-self.img_batbg.size[0]+2,4))
	def quit(self):
		self.stop()
		self.running=0
		self.lock.signal()
		appuifw.app.set_exit()
	def take_shot(self):
		self.img.save(u'e:\\pmq_shot.jpg')
	def restart_game(self):
		self.stop()
		self.s_count = 0
		self.k_count = 0
		self.farr = []
		self.farr_len = 0
		self.last4 = [('',''),('',''),('',''),('','')]
		self.five = []
		self.three = []
		self.settings(1)
		self.get_files()
		if self.farr_len>5:
			self.next()
	def settings(self,item):
		cfg_path = self.path+os.sep+u'PMQ.cfg'
		if e32.in_emulator():	cfg_path = u'c:\\PMQ.cfg'
		if (item==0):#write settings
			F=codecs.open(cfg_path,'w','utf-8')
			F.write(self.mdir+'\n')
			mext=u''
			for ext in self.mext:
				mext = mext+ext+u';'
			F.write(mext+'\n')
			F.close()
		if (item==1):#read settings
			if not os.path.exists(cfg_path):
				if e32.in_emulator():	self.mdir=u"c:\\Sounds\\Digital";
				else:	self.mdir=u"e:\\Sounds\\Digital";
				fexts=string.split(u'.mp3;.wav;.ogg',';')
				self.mext = []
				for fext in fexts:
					self.mext.append(unicode(fext))
				self.settings(0)
			F=codecs.open(cfg_path,'r','utf-8')
			line=F.readline()
			line=line[:-1]
			self.mdir = unicode(line)
			line=F.readline()
			line=line[:-1]
			fexts=string.split(line,';')
			self.mext = []
			for fext in fexts:
				self.mext.append(unicode(fext))
		if (item==2):
			self.stop()
			old_img=self.img
			self.img=None
			line=appuifw.query(u"Enter path:\n(e:\\Sounds\\Digital)", 'text',self.mdir)
			if not e32.in_emulator():	self.snd.stop()
			if line:
				if os.path.exists(unicode(line)):
					self.mdir=unicode(line)
					self.settings(0)
				else:
					appuifw.note(u'Path not exists!')
			self.img=old_img
			self.restart_game()
		if (item==3):
			self.stop()
			old_img=self.img
			self.img=None
			mext=u''
			for ext in self.mext:
				if (ext!=u''):	mext = mext+ext+u';'
			line=appuifw.query(u"Enter music ext:\n(.mp3;.ogg;.wav)", 'text',mext)
			if not e32.in_emulator():	self.snd.stop()
			if line:
				fexts=string.split(line,';')
				self.mext = []
				for fext in fexts:
					self.mext.append(unicode(fext))
				self.settings(0)
			self.img=old_img
			self.restart_game()

if __name__ == '__main__':
	game = PMQGame()
	game.run()